.nolist
include \masm32\include\masm32rt.inc
.list
.data?
hInst dd ?
.code
.data
ClassName       DB "StdWindow",0
szAppName       DB "test",0
align 4
wc WNDCLASS <CS_HREDRAW or CS_VREDRAW,WndProc,0,0,0,0,0,0,0,ClassName>

.data?
message MSG <>
hwindow dd ? 
hMenu   dd ?
SWidth  dd ?    ; screen width
SHeight dd ?    ; screen height
.code
inv equ invoke
Program:
    inv InitCommonControls
    inv GetModuleHandle,0
    mov hInst,eax
    mov wc.hInstance,eax   ; save for later
    inv LoadIcon, 0, IDI_APPLICATION
    mov wc.hIcon,eax
    inv LoadCursor, 0, IDC_ARROW
    mov wc.hCursor,eax
    inv RegisterClass, addr wc
    ;inv LoadMenu, hInst, MNU
    mov hMenu,0;eax
    call GetScreenSetup    
    inv CreateWindowEx,WS_EX_CLIENTEDGE,addr ClassName,addr szAppName,WS_OVERLAPPEDWINDOW,
           0,0,SWidth,SHeight,0,hMenu,hInst,0
    mov hwindow,eax
    inv ShowWindow, hwindow, SW_SHOWNORMAL
    inv UpdateWindow, hwindow
    .repeat
        inv GetMessage,addr message,0,0,0
        .break .if !eax
        inv TranslateMessage,addr message
        inv DispatchMessage,addr message
    .until 0
    inv ExitProcess,message.wParam

GetScreenSetup proc
    inv GetSystemMetrics,SM_CXSCREEN  ; screen width
    mov SWidth,eax
    inv GetSystemMetrics,SM_CYSCREEN
    mov SHeight,eax
	ret
GetScreenSetup endp

.data?
hWin dd ?   ; dialog handle
hdc  dd ?   ; temp dc of dialog
mdc  dd ?   ; memory dc of hidden buffer
mdc2 dd ?   ; scratch for loading images

hbm1 dd ?   ; bitmap for hidden buffer mdc
hbm2 dd ?   ; mdc2

crect RECT <>
mwidth  equ crect.right  ; total width of client rectangle in pixels
mheight equ crect.bottom ; total height in pixels

hbrush1 dd ?
hbrush2 dd ?
usevert dd ?
.data
toggle dd 1
.code
TimerProc proc hwnd,imsg,tid,ctime  ; timer callback routine.
    inv InvalidateRect,hWin,0,0
	ret
TimerProc endp

WndProc Proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    local ps:PAINTSTRUCT

    mov eax,uMsg
    .if eax==WM_COMMAND
    .elseif eax==WM_ERASEBKGND
        mov eax,1
        jmp WndRet
    .elseif eax==WM_LBUTTONDOWN
        inv InvalidateRect,hWin,0,0
    .elseif eax==WM_PAINT

        inv BeginPaint,hWnd,ADDR ps
        mov hdc,eax
        .if usevert
        	.if VblankOk
                call WaitForVerticalBlank
        	.endif
        .endif
        neg toggle
        .if sign?
            inv BitBlt,hdc,0,0,mwidth,mheight,mdc,0,0,SRCCOPY
        .else
            inv BitBlt,hdc,0,0,mwidth,mheight,mdc2,0,0,SRCCOPY
        .endif
        inv EndPaint,hWnd,ADDR ps
        
    .elseif eax==WM_SIZE
        .if mdc==0
            inv GetClientRect,hWin,addr crect    ; get the size needed for the bitmap
            inv GetDC,hWin  ; get dc's
            mov hdc,eax
        
            inv CreateCompatibleDC,hdc      ; create dc for hidden buffer
            mov mdc,eax
            inv SetBkMode,mdc,TRANSPARENT
            inv CreateCompatibleBitmap,hdc, mwidth, mheight ; make a hidden buffer of the appropriate size
            mov hbm1,eax
            inv SelectObject, mdc,hbm1
            inv DeleteObject,eax        ; delete old bitmap
            inv CreateSolidBrush,002492ffh
            mov hbrush1,eax
            inv SelectObject,mdc,eax
        
            inv CreateCompatibleDC,hdc      ; create dc for hidden buffer
            mov mdc2,eax
            inv SetBkMode,mdc2,TRANSPARENT
            inv CreateCompatibleBitmap,hdc, mwidth, mheight ; make a hidden buffer of the appropriate size
            mov hbm2,eax
            inv SelectObject, mdc2, hbm2
            inv DeleteObject,eax        ; delete old bitmap
            inv CreateSolidBrush,00818181h
            mov hbrush2,eax
            inv SelectObject,mdc2,eax
        
            inv FillRect,mdc,addr crect,hbrush1
            inv FillRect,mdc2,addr crect,hbrush2
        
            inv ReleaseDC,hWin,hdc
            inv SetTimer,hWin,999,150,addr TimerProc
        .endif

    .elseif eax==WM_KEYDOWN
        not usevert
    .elseif eax==WM_CREATE

        m2m hWin,hWnd
        call StartDD    ; set up for vertical blanking
        
    .elseif eax==WM_DESTROY

        inv PostQuitMessage,0
        mov eax,wParam
        jmp WndRet

    .endif
LpExit:
    inv DefWindowProc, hWnd, uMsg, wParam, lParam
WndRet:
	ret
WndProc endp

;-----code to get vertical blanking to prevent flicker from MichaelW------------
uselib ddraw	; to find vertical blanking to prevent flicker

DDO_GetScanLine EQU 64
DDERR_VERTICALBLANKINPROGRESS EQU ((1 shl 31)or(876h shl 16)or(537))

.data
lpdd_1   dd 0
scanLine dd 0
VblankOk dd 0	; flag that it is ok to wait for vertical blanking
.code

StartDD proc
    invoke DirectDrawCreate,0,ADDR lpdd_1,0	; Create a default DirectDraw object.
    or eax,eax
    jnz DDNoGood
    call DDGetScanLine	; Make sure DDGetScanLine doesn't have any obvious problems.
    or eax,eax
    jnz DDNoGood
	mov VblankOk,1	; ok to use
DDNoGood:   
	ret
StartDD EndP

DDGetScanLine proc
    push offset scanLine
    push lpdd_1
    mov  eax, lpdd_1
    mov  eax, [eax]
    call DWORD PTR[eax+DDO_GetScanLine]
    ret
DDGetScanLine endp

WaitForVerticalBlank proc
    .repeat
        call DDGetScanLine
    .until eax != DDERR_VERTICALBLANKINPROGRESS
    .repeat
        call DDGetScanLine
    .until eax == DDERR_VERTICALBLANKINPROGRESS   
    ret
WaitForVerticalBlank endp

end Program